Package com.io7m.cedarbridge.schema.compiled.internal

# Class CBTypeParameter

java.lang.Object
com.io7m.cedarbridge.schema.compiled.internal.CBTypeParameter

All Implemented Interfaces:
  `CBTypeParameterType`

public final class CBTypeParameter extends Object implements CBTypeParameterType
A type parameter.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `CBTypeParameter(String inName, int inIndex, List<String> inDocumentation)`
  Construct a type parameter.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `List<String>`
  `documentation()`
  `int`
  `index()`
  `String`
  `name()`
  `CBTypeDeclarationType`
  `owner()`
  `void`
  `setOwner(CBTypeDeclarationType type)`
  Set the owner of the type.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### CBTypeParameter

    public CBTypeParameter(String inName, int inIndex, List<String> inDocumentation)
    Construct a type parameter.
    Parameters:
      `inName` - The parameter name
      `inIndex` - The parameter index
      `inDocumentation` - The documentation

- ## Method Details

  - ### setOwner

    public void setOwner(CBTypeDeclarationType type)
    Set the owner of the type.
    Parameters:
      `type` - The owner declaration

  - ### index

    public int index()
    Specified by:
      `index` in interface `CBTypeParameterType`
    Returns:
      The index of this type parameter on the owning type (starting from 0)

  - ### name

    public String name()
    Specified by:
      `name` in interface `CBTypeParameterType`
    Returns:
      The name of the type parameter

  - ### owner

    public CBTypeDeclarationType owner()
    Specified by:
      `owner` in interface `CBTypeParameterType`
    Returns:
      The type declaration parameterized by this parameter

  - ### documentation

    public List<String> documentation()
    Specified by:
      `documentation` in interface `CBTypeParameterType`
    Returns:
      The documentation for the parameter